<?php
// $Id: patchdoq.admin.inc,v 1.1.2.1 2009/04/19 20:28:45 doq Exp $

/**
 * @file
 * patchdoq admin functions.
 *
 * @todo Bulk apply/unapply patches. User checks patches to apply using checkbox/check all functionality.
 * @todo Warning "change site to maintainance mode".
 * @todo Weights for patches?
 */

/**
 * Settings form.
 */
function patchdoq_settings(&$form_state) {
  $patches = patchdoq_list_patches();

  foreach ($patches as $id => $patch) {
    $form['names'][$id] = array('#value' => $patch['name']);
    $form['descriptions'][$id] = array('#value' => $patch['description']);
    
    if (patchdoq_patch_is_applied($patch)) {
      $form['operation'][$id] = array(
        '#value' => l(t('unapply'), 'admin/build/patchdoq/unapply/'. $id),
      );
    }
    else {
      $form['operation'][$id] = array(
        '#value' => l(t('apply'), 'admin/build/patchdoq/apply/'. $id),
      );
    }
  }

  return $form;
}


/**
 * Theme pipe order configuration form.
 *
 * @ingroup themeable
 */
function theme_patchdoq_settings($form) {
  $header = array(t('Name'), t('Description'), t('Operations'));
  $rows = array();
  foreach (element_children($form['names']) as $id) {
    // Don't take form control structures.
    if (is_array($form['names'][$id])) {
      $rows[] = array(
        'data' => array(
          drupal_render($form['names'][$id]),
          drupal_render($form['descriptions'][$id]),
          drupal_render($form['operation'][$id])
        ),
      );
    }
  }

  $output = theme('table', $header, $rows);
  $output .= drupal_render($form);

  return $output;
}

/**
 * Patch apply form.
 */
function patchdoq_apply_form($form_state, $patch) {
  if (patchdoq_patch_apply($patch)) {
    drupal_set_message(t('Patch %patch was applied successfully.', array('%patch' => $patch['name'])));
  }
  else {
    drupal_set_message(t('There was an error while applying patch %patch.', array('%patch' => $patch['name'])), 'error');
  }
  drupal_goto('admin/build/patchdoq');
}

/**
 * Patch unapply form.
 */
function patchdoq_unapply_form($form_state, $patch) {
  if (patchdoq_patch_reverse($patch)) {
    drupal_set_message(t('Patch %patch was unapplied successfully.', array('%patch' => $patch['name'])));
  }
  else {
    drupal_set_message(t('There was an error while unapplying patch %patch.', array('%patch' => $patch['name'])), 'error');
  }
  drupal_goto('admin/build/patchdoq');
}
